package cgl.axis.services.uddi_extended;

import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.Log;

/**
 * @author Mehmet S. Aktas (maktas@indiana.edu)
 */
public class UDDI_Extended_Helper {

    private static Log log = LogFactory.getLog(UDDI_Extended_Helper.class);

    public UDDI_Extended_Helper() {
    }


    public cgl.axis.services.uddi.uddi_ext_schema.MetadataBag constructAXIS_MetadataBag(java.util.Vector  fthpis_attributeVector) {
        cgl.axis.services.uddi.uddi_ext_schema.MetadataBag metadatabag = null;
        if (fthpis_attributeVector != null && fthpis_attributeVector.size() != 0) {
          metadatabag = new cgl.axis.services.uddi.uddi_ext_schema.MetadataBag();
        int size = fthpis_attributeVector.size();
        log.info("fthpis_properyVector.size = " + size);
        cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute [] serviceAttributeArray =
            new cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute[size];

        int serviceAttribute_count = 0;
        for (java.util.Iterator iter = fthpis_attributeVector.iterator();
             iter.hasNext(); ) {
          cgl.fthpis.datatype.attribute.Attribute fthpis_attribute =
              (cgl.fthpis.datatype.attribute.Attribute) iter.next();

          cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute axis_serviceAttribute =
              new cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute();

          //service key
          String service_key = fthpis_attribute.getServiceKey();

          //serviceAttribute key
          String serviceAttribute_key = fthpis_attribute.getAttributeKey();

          //CONSTRUCT AXIS CATEGORYBAG
          org.apache.juddi.datatype.CategoryBag fthpis_categoryBag = fthpis_attribute.
              getCategoryBag();

          cgl.axis.services.uddi.uddi_schema.CategoryBag axis_categoryBag = null;
          if (fthpis_categoryBag != null) {
            axis_categoryBag = constructAXIS_CategoryBag(fthpis_categoryBag);
          }

          //CONSTRUCT AXIS METADATA FIELDS
          if (fthpis_attribute != null) {
              if (fthpis_attribute.getAttributeName() != null)
                  axis_serviceAttribute.setName(fthpis_attribute.getAttributeName().getAttributeName());
              if (fthpis_attribute.getAttributeValueType() != null)
                  axis_serviceAttribute.setValueType(fthpis_attribute.getAttributeValueType().getAttributeValueType());
              if (fthpis_attribute.getAttributeValue() != null)
                  axis_serviceAttribute.setValue(fthpis_attribute.getAttributeValue().getAttributeValueAsString());
          }

          //CONSTRUCT AXIS LEASE
          cgl.fthpis.datatype.lease.Lease juddiLease =
              fthpis_attribute.getLease();
          cgl.axis.services.uddi.uddi_ext_schema.Lease lease = null;
          if (juddiLease != null) {
            lease = constructAXIS_Lease(juddiLease);
          }

          //set service key
          String servicekey = fthpis_attribute.getServiceKey();
          servicekey = "uuid:" + servicekey;
          org.apache.axis.types.URI key = null;
          try {
              key = new org.apache.axis.types.URI(servicekey);
          } catch (Exception ex) {
          }

          //set serviceAttribute_key
          String serviceAttributekey = fthpis_attribute.getAttributeKey();
          serviceAttributekey = "uuid:" + serviceAttributekey;
          org.apache.axis.types.URI mkey = null;

          try {
            mkey = new org.apache.axis.types.URI(serviceAttributekey);
          } catch (Exception ex) {
          }

          axis_serviceAttribute.setAttributeKey(mkey);
          axis_serviceAttribute.setServiceKey(key);
          axis_serviceAttribute.setCategoryBag(axis_categoryBag);
          axis_serviceAttribute.setLease(lease);
          serviceAttributeArray[serviceAttribute_count] = axis_serviceAttribute;
          serviceAttribute_count++;
        }
        log.info("serviceAttribute array size = " + serviceAttributeArray.length);
        metadatabag.setServiceAttribute(serviceAttributeArray);
        }
        return metadatabag;
    }

    public cgl.axis.services.uddi.uddi_ext_schema.Lease constructAXIS_Lease(cgl.fthpis.datatype.lease.Lease juddiLease) {
      cgl.axis.services.uddi.uddi_ext_schema.Lease lease = null;
      if (juddiLease != null) {
        if (juddiLease != null) {
          lease = new cgl.axis.services.uddi.uddi_ext_schema.Lease();
          if (juddiLease.getLeaseStartDate() != null) {
              String lease_start_timestamp = juddiLease.getLeaseStartDate().getLeaseStartDate();
              lease.setLeaseStartTimeStamp(lease_start_timestamp);
          }
          if (juddiLease.getLeaseExpirationDate() != null) {
              String lease_expiration_timestamp = juddiLease.getLeaseExpirationDate().getLeaseExpirationDate();
              lease.setLeaseExpirationTimeStamp(lease_expiration_timestamp);
          }
        }
      }
      return lease;
    }

    public cgl.axis.services.uddi.uddi_schema.CategoryBag constructAXIS_CategoryBag(org.apache.juddi.datatype.CategoryBag fthpis_categoryBag) {
      cgl.axis.services.uddi.uddi_schema.CategoryBag axis_categoryBag = null;
      if (fthpis_categoryBag != null) {
        axis_categoryBag = new cgl.axis.services.uddi.uddi_schema.CategoryBag();
        int category_size = fthpis_categoryBag.size();
        cgl.axis.services.uddi.uddi_schema.KeyedReference[] keyReference_array =
            new cgl.axis.services.uddi.uddi_schema.KeyedReference[category_size];

        int keyreference_count = 0;
        for (java.util.Iterator it = fthpis_categoryBag.
             getKeyedReferenceVector().iterator(); it.hasNext(); ) {

          org.apache.juddi.datatype.KeyedReference fthpis_keyReference = (
              org.apache.juddi.datatype.KeyedReference) it.next();
          cgl.axis.services.uddi.uddi_schema.KeyedReference axis_keyReference =
              new cgl.axis.services.uddi.uddi_schema.KeyedReference();
          String tmodel_key = fthpis_keyReference.getTModelKey();
          org.apache.axis.types.URI tmodel_uri = new org.apache.axis.types.URI();

            axis_keyReference.setTModelKey(tmodel_uri);

              axis_keyReference.setKeyName(fthpis_keyReference.getKeyName());
              axis_keyReference.setKeyValue(fthpis_keyReference.getKeyValue());
              keyReference_array[keyreference_count] = axis_keyReference;
              keyreference_count++;

        }
        axis_categoryBag.setKeyedReference(keyReference_array);
      }
      return axis_categoryBag;
    }



    public cgl.axis.services.uddi.uddi_schema.CategoryBag constructOGC_AXIS_CategoryBag(org.apache.juddi.datatype.CategoryBag fthpis_categoryBag) {
      cgl.axis.services.uddi.uddi_schema.CategoryBag axis_categoryBag = null;
      if (fthpis_categoryBag != null) {
        axis_categoryBag = new cgl.axis.services.uddi.uddi_schema.CategoryBag();
        int category_size = fthpis_categoryBag.size();
        cgl.axis.services.uddi.uddi_schema.KeyedReference[] keyReference_array =
            new cgl.axis.services.uddi.uddi_schema.KeyedReference[category_size];

        int keyreference_count = 0;
        for (java.util.Iterator it = fthpis_categoryBag.
             getKeyedReferenceVector().iterator(); it.hasNext(); ) {

          org.apache.juddi.datatype.KeyedReference fthpis_keyReference = (
              org.apache.juddi.datatype.KeyedReference) it.next();
          cgl.axis.services.uddi.uddi_schema.KeyedReference axis_keyReference =
              new cgl.axis.services.uddi.uddi_schema.KeyedReference();
          String tmodel_key = fthpis_keyReference.getTModelKey();
          tmodel_key = "uuid:" + tmodel_key;

          org.apache.axis.types.URI tmodel_uri = null;
          try {
              tmodel_uri = new org.apache.axis.types.URI(tmodel_key);
          } catch (Exception ex) {
          }

            axis_keyReference.setTModelKey(tmodel_uri);
            if (tmodel_key == "uuid:65BEE600-F1C1-11D6-B493-B8A03C50A862") {
              axis_keyReference.setKeyName(fthpis_keyReference.getKeyName());
              axis_keyReference.setKeyValue(fthpis_keyReference.getKeyValue());
              keyReference_array[keyreference_count] = axis_keyReference;
              keyreference_count++;
            }
        }
        axis_categoryBag.setKeyedReference(keyReference_array);
      }
      return axis_categoryBag;
    }


    public cgl.axis.services.uddi.uddi_schema.Name [] constructAXIS_Name(java.util.Vector nameVec) {
      cgl.axis.services.uddi.uddi_schema.Name[] axis_name_array = null;
      if (nameVec != null) {
        int nameVecSize = nameVec.size();
        axis_name_array = new cgl.axis.services.uddi.uddi_schema.Name[nameVecSize];
        int nameVec_count = 0;
        for (java.util.Iterator it = nameVec.iterator(); it.hasNext(); ) {
          org.apache.juddi.datatype.Name business_name = (org.apache.
              juddi.
              datatype.Name) it.next();
          cgl.axis.services.uddi.uddi_schema.Name name =
              new cgl.axis.services.uddi.uddi_schema.Name(business_name.
              getValue());
          axis_name_array[nameVec_count] = name;
          nameVec_count++;
        }
      }
      return axis_name_array;
    }

    public cgl.axis.services.uddi.uddi_schema.Description [] constructAXIS_Description(java.util.Vector fthpis_description_vector) {
      //set description array of the binding template
      cgl.axis.services.uddi.uddi_schema.Description[] axis_temp_desc_array = null;
      if (fthpis_description_vector != null) {
        int descVecSize = fthpis_description_vector.size();
        axis_temp_desc_array = new cgl.axis.services.uddi.uddi_schema.Description[descVecSize];
        int descVec_count = 0;
        for (java.util.Iterator it = fthpis_description_vector.iterator(); it.hasNext(); ) {
          org.apache.juddi.datatype.Description business_description =
              (org.apache.juddi.datatype.Description) it.next();
          cgl.axis.services.uddi.uddi_schema.Description description =
              new cgl.axis.services.uddi.uddi_schema.Description(
              business_description.
              getValue());
          axis_temp_desc_array[descVec_count] = description;
          descVec_count++;
        }
      }
      return axis_temp_desc_array;
    }

    public cgl.axis.services.uddi.uddi_schema.BindingTemplates constructAXIS_BindingTemplates(org.apache.juddi.datatype.binding.BindingTemplates fthpis_bindingTemplates) {
          cgl.axis.services.uddi.uddi_schema.BindingTemplates axis_bindingTemplates = null;
          if (fthpis_bindingTemplates != null) {
            axis_bindingTemplates = new cgl.axis.services.uddi.uddi_schema.
                BindingTemplates();

            java.util.Vector templateVector = fthpis_bindingTemplates.
                getBindingTemplateVector();
            int template_size = templateVector.size();
            log.info("constructAXIS_BindingTemplates => template size = " + template_size);
            cgl.axis.services.uddi.uddi_schema.BindingTemplate[] bindingtemplate_array =
                new cgl.axis.services.uddi.uddi_schema.BindingTemplate[template_size];
            int template_count = 0;
            for (java.util.Iterator iterator = templateVector.iterator();
                 iterator.hasNext(); ) {

              org.apache.juddi.datatype.binding.BindingTemplate binding =
                  (org.apache.juddi.datatype.binding.BindingTemplate) iterator.
                  next();

              cgl.axis.services.uddi.uddi_schema.BindingTemplate bindingTemp =
                  new cgl.axis.services.uddi.uddi_schema.BindingTemplate();

              //set access point for binding template
              org.apache.juddi.datatype.binding.AccessPoint accesspoint =
                  binding.getAccessPoint();

              if (accesspoint != null) {

                cgl.axis.services.uddi.uddi_schema.AccessPoint axis_accessPoint =
                    new cgl.axis.services.uddi.uddi_schema.AccessPoint();
                axis_accessPoint.setValue(accesspoint.getURL());
                axis_accessPoint.setUseType(accesspoint.getURLType());

                bindingTemp.setAccessPoint(axis_accessPoint);
              }

              //set description array of the binding template
              java.util.Vector descVec = binding.getDescriptionVector();
              if (descVec != null) {
                cgl.axis.services.uddi.uddi_schema.Description[] axis_temp_desc_array =
                    constructAXIS_Description(descVec);
                bindingTemp.setDescription(axis_temp_desc_array);
              }

              //set service key
              String service_key = binding.getServiceKey();
              service_key = "uuid:" + service_key;
              org.apache.axis.types.URI key = null;
              try {
                  key = new org.apache.axis.types.URI(service_key);
              } catch (Exception ex) {
              }
              bindingTemp.setServiceKey(key);

              //CONSTRUCT AXIS CATEGORYBAG
              org.apache.juddi.datatype.CategoryBag fthpis_categoryBag =binding.getCategoryBag();
              cgl.axis.services.uddi.uddi_schema.CategoryBag axis_categoryBag = null;
              if (fthpis_categoryBag != null) {
                axis_categoryBag = constructAXIS_CategoryBag(fthpis_categoryBag);
                bindingTemp.setCategoryBag(axis_categoryBag);
              }

              //set TModelInstance
              bindingTemp.setTModelInstanceDetails(null);
              bindingtemplate_array[template_count] = bindingTemp;
              template_count++;
            }
            axis_bindingTemplates.setBindingTemplate(bindingtemplate_array);
          }
      return axis_bindingTemplates;
    }


    public java.util.Vector constructFTHPIS_NameVector(cgl.axis.services.uddi.uddi_schema.
        Name[] name_array) {
      java.util.Vector nameVector = null;
      if (name_array != null) {
        nameVector = new java.util.Vector();
        int length = name_array.length;
        for (int t = 0; t < length; t++) {
          cgl.axis.services.uddi.uddi_schema.Name name =
              name_array[t];
          nameVector.add(new org.apache.juddi.datatype.Name(
              name.getValue().toString()));
        }
      }
      return nameVector;
    }

    public java.util.Vector constructFTHPIS_DescVector(cgl.axis.services.uddi.uddi_schema.
        Description[] description_array) {
      java.util.Vector descVector = null;
      if (description_array != null) {
        descVector = new java.util.Vector();
        int length = description_array.length;
        for (int t = 0; t < length; t++) {
          cgl.axis.services.uddi.uddi_schema.Description description =
              description_array[t];
          if (description != null) {
              descVector.add(new org.apache.juddi.datatype.Description(
                      description.getValue().toString()));
          }
        }
      }
      return descVector;
    }

    public org.apache.juddi.datatype.request.FindQualifiers constructFTHPIS_FindQualifiers(cgl.axis.services.uddi.uddi_schema.FindQualifiers axis_findqualifiers) {
      org.apache.juddi.datatype.request.FindQualifiers fthpis_findQualifiers = null;
      //CONSTRUCT FINDQUALIFIERS
      if (axis_findqualifiers != null) {
      String [] findqualifier_array = axis_findqualifiers.getFindQualifier();
      fthpis_findQualifiers = new org.apache.juddi.datatype.request.FindQualifiers();
      java.util.Vector findQualifierVector = new java.util.Vector();
      int size = findqualifier_array.length;
      for (int i = 0; i < size; i++) {
        String fieldname = findqualifier_array[i];
        org.apache.juddi.datatype.request.FindQualifier fthpis_findQualifier
            = new org.apache.juddi.datatype.request.FindQualifier(fieldname);
        findQualifierVector.add(fthpis_findQualifier);
      }
      fthpis_findQualifiers.setFindQualifierVector(findQualifierVector);
      }
      return fthpis_findQualifiers;
    }

    public org.apache.juddi.datatype.CategoryBag constructFTHPIS_CategoryBag(
        cgl.axis.services.uddi.uddi_schema.CategoryBag category_bag) {
      org.apache.juddi.datatype.CategoryBag categoryBag = null;

      if (category_bag != null) {
        cgl.axis.services.uddi.uddi_schema.KeyedReference[] reference_array =
            category_bag.getKeyedReference();
        log.info("reference_array = " + reference_array);
        if (reference_array != null) {
          java.util.Vector keyedReferenceVector = new java.util.Vector();

          log.info("reference_array.length = " + reference_array.length);
          for (int i = 0; i < reference_array.length; i++) {
            cgl.axis.services.uddi.uddi_schema.KeyedReference kr = reference_array[i];
            log.info("keyname = " + kr.getKeyName());
            log.info("keyvalue = " + kr.getKeyValue());
          }

          for (int t = 0; t < reference_array.length; t++) {
            org.apache.juddi.datatype.KeyedReference keyedReference = new
                org.apache.juddi.datatype.KeyedReference();
            if (reference_array[t].getKeyName() != null) {
              keyedReference.setKeyName(reference_array[t].getKeyName());
              log.info("in constructFTHPIS_CategoryBag keyname = > " + t +
                                 " " +
                                 reference_array[t].getKeyName());
            }
            if (reference_array[t].getKeyValue() != null) {
              keyedReference.setKeyValue(reference_array[t].getKeyValue());
              log.info("in constructFTHPIS_CategoryBag keyvalue = > " +
                                 t + " " +
                                 reference_array[t].getKeyValue());
            }
            if (reference_array[t].getTModelKey() != null) {
                String tmodel_key = reference_array[t].getTModelKey().toString();
                java.util.StringTokenizer tokenizer =
                    new java.util.StringTokenizer(tmodel_key, "uuid:");
                tmodel_key = "";
                while (tokenizer.hasMoreElements()) {
                  tmodel_key = tmodel_key + tokenizer.nextToken();
                }
                log.info("****** updated tmodel_key = " + tmodel_key);
                keyedReference.setTModelKey(tmodel_key);
            }
            keyedReferenceVector.add(keyedReference);
          }
          categoryBag = new org.apache.juddi.datatype.CategoryBag();
          categoryBag.setKeyedReferenceVector(keyedReferenceVector);
        }
      }
      return categoryBag;
    }

    public cgl.fthpis.datatype.lease.Lease constructFTHPIS_Lease(
        cgl.axis.services.uddi.uddi_ext_schema.Lease lease) {
      cgl.fthpis.datatype.lease.Lease fthpis_lease = null;
      if (lease != null) {
        fthpis_lease = new cgl.fthpis.datatype.lease.Lease();
            //this part is for insertion
            if (lease.isIsInfinite()) {
                fthpis_lease.setIsInfinite("true");
            } else {
                fthpis_lease.setIsInfinite("false");
                if (lease.getLeaseStartTimeStamp() != null) {
                    fthpis_lease.setLeaseTimeOut(lease.getLeaseStartTimeStamp());
                }
            }
        //this part for finding stuff
        if (lease.getLeaseExpirationTimeStamp() != null) {
            fthpis_lease.setLeaseExpirationDate(lease.getLeaseExpirationTimeStamp());
        } else {
            long current_time = System.currentTimeMillis();
            fthpis_lease.setLeaseTimeOut((new Long(current_time)).toString());
        }
      }
      return fthpis_lease;
    }

    public cgl.fthpis.datatype.attribute.AttributeBag
        constructFTHPIS_AttributeBag(cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute[]
                                   axis_serviceAttribute_array) {
      log.info("constructFTHPIS_AttributeBag => I ");
      cgl.fthpis.datatype.attribute.AttributeBag attributeBag = null;
      if (axis_serviceAttribute_array != null ) {

//          GenTree tree = new GenTree();
          if (axis_serviceAttribute_array != null) {

              java.util.Vector attributeBag_Vector = new java.util.Vector();
              for (int i = 0; i < axis_serviceAttribute_array.length; i++) {
                  cgl.axis.services.uddi.uddi_ext_schema.ServiceAttribute
                          serviceAttribute = axis_serviceAttribute_array[i];

                  log.info("constructFTHPIS_AttributeBag => I => service attribute = " + serviceAttribute);

                  cgl.fthpis.datatype.attribute.Attribute attribute =
                          new cgl.fthpis.datatype.attribute.Attribute();

                  //CONSTRUCT SERVICEKEY
                  org.apache.axis.types.URI axis_servicekey =
                          serviceAttribute.getServiceKey();
                  String service_key = "";
                  if (axis_servicekey != null) {
                      service_key = axis_servicekey.toString();
                      java.util.StringTokenizer tokenizer =
                              new java.util.StringTokenizer(service_key,
                              "uuid:");
                      service_key = tokenizer.nextToken();
                      //log.info("****** updated service_key = " + service_key);
                      attribute.setServiceKey(service_key);
                  }

                  //CONSTRUCT BINDINGKEY
                  org.apache.axis.types.URI axis_bindingkey =
                          axis_serviceAttribute_array[i].getBindingKey();
                  String binding_key = "";
                  if (axis_bindingkey != null) {
                      binding_key = axis_servicekey.toString();
                      java.util.StringTokenizer tokenizer =
                              new java.util.StringTokenizer(binding_key,
                              "uuid:");
                      binding_key = tokenizer.nextToken();
                      //log.info("****** updated binding_key = " + binding_key);
                      //attribute.setBindingKey(binding_key);
                      //attribute.setBindingKey("NULL");
                  }

                  org.apache.axis.types.URI axis_attributekey =
                          axis_serviceAttribute_array[i].getAttributeKey();
                  String attribute_key = null;
                  if (axis_attributekey != null) {
                      attribute_key = axis_attributekey.toString();
                      java.util.StringTokenizer tokenizer =
                              new java.util.StringTokenizer(attribute_key,
                              "uuid:");
                      attribute_key = tokenizer.nextToken();
                      attribute.setAttributeKey(attribute_key);
                  }

                  attribute.setAttributeName(new cgl.fthpis.datatype.attribute.
                                             AttributeName(serviceAttribute.
                          getName()));
                  log.info(" serviceAttribute.getName() = " +
                           serviceAttribute.getName());
                  attribute.setAttributeValueType(new cgl.fthpis.datatype.attribute.
                                             AttributeValueType(serviceAttribute.
                          getValueType()));
                  log.info(" serviceAttribute.getValueType() = " +
                           serviceAttribute.getValueType());
                  attribute.setAttributeValue(new cgl.fthpis.datatype.attribute.
                                              AttributeValue(serviceAttribute.
                          getValue()));
                  log.info(" serviceAttribute.getValue() = " +
                           serviceAttribute.getValue());

                  //if there is a attribute find qualifier I need to add this into attribute
                  if (serviceAttribute.getFindQualifier() != null) {
                      String qualifier = serviceAttribute.getFindQualifier();
                      attribute.setAttributeFindQualifier(new cgl.fthpis.
                              datatype.attribute.AttributeFindQualifier(
                              qualifier));
                  }

                  //categorybag
                  org.apache.juddi.datatype.CategoryBag propCategory =
                          new org.apache.juddi.datatype.CategoryBag();
                  java.util.Vector keyedReferenceVector = new java.util.Vector();
                  if (serviceAttribute.getCategoryBag() != null) {
                      for (int j = 0;
                                   j < serviceAttribute.getCategoryBag().
                                   getKeyedReference().length; j++) {
                          cgl.axis.services.uddi.uddi_schema.KeyedReference kr =
                                  serviceAttribute.
                                  getCategoryBag().getKeyedReference()[j];
                          org.apache.juddi.datatype.KeyedReference
                                  keyedReference =
                                          new org.apache.juddi.datatype.
                                          KeyedReference();
                          String keyname = kr.getKeyName();
                          String keyvalue = kr.getKeyValue();
                          keyedReference.setKeyName(keyname);
                          keyedReference.setKeyValue(keyvalue);
                          keyedReferenceVector.add(keyedReference);
                          //log.info("keyname = " + kr.getKeyName().getValue());
                          //log.info("keyvalue = " +
                          //                   kr.getKeyValue().getValue().toString());
                      }
                  }
//                  if (serviceAttribute.getBoundingBox() != null) {
//                      if (serviceAttribute.getBoundingBox().getSpatial() != null) {
//                          cgl.axis.services.uddi.uddi_ext_schema.Spatial
//                                  spatial_bbox =
//                                          serviceAttribute.getBoundingBox().
//                                          getSpatial();
//                          java.lang.Integer min_lat = new java.lang.Integer(
//                                  spatial_bbox.getMinLat());
//                          java.lang.Integer max_lat = new java.lang.Integer(
//                                  spatial_bbox.getMaxLat());
//                          java.lang.Integer min_lon = new java.lang.Integer(
//                                  spatial_bbox.getMinLon());
//                          java.lang.Integer max_lon = new java.lang.Integer(
//                                  spatial_bbox.getMaxLon());
//                          int minx = min_lat.intValue();
//                          int maxx = max_lat.intValue();
//                          int miny = min_lon.intValue();
//                          int maxy = max_lon.intValue();
//                          tree.generateTree(minx, miny, maxx, maxy);
//                          java.util.Vector category_vec = tree.categoryTree();
//                          java.util.Vector vec = new java.util.Vector();
//                          for (java.util.Iterator iter = category_vec.iterator();
//                                  iter.hasNext(); ) {
//                              org.apache.juddi.datatype.KeyedReference
//                                      keyreference =
//                                              (org.apache.juddi.datatype.
//                                               KeyedReference) iter.
//                                              next();
//                              keyedReferenceVector.add(keyreference);
//                          }
//                      }
//                  }
                  propCategory.setKeyedReferenceVector(keyedReferenceVector);
                  attribute.setCategoryBag(propCategory);

                  //lease
                  cgl.axis.services.uddi.uddi_ext_schema.Lease lease =
                          serviceAttribute.getLease();
                  cgl.fthpis.datatype.lease.Lease fthpis_lease = null;
                  if (lease != null) {
                      fthpis_lease = constructFTHPIS_Lease(lease);
                  }
                  attribute.setLease(fthpis_lease);
                  //version
                  attribute.setAttributeVersion(1);
                  //add into attribute bag
                  attributeBag_Vector.add(attribute);
              }

              attributeBag = new cgl.fthpis.datatype.attribute.AttributeBag();
              attributeBag.setAttributeVector(attributeBag_Vector);
          }
      }
      return attributeBag;
    }

    public org.apache.juddi.datatype.binding.BindingTemplates constructFTHPIS_BindingTemplates(cgl.axis.services.uddi.uddi_schema.BindingTemplates axis_bindingtemplates) {
      org.apache.juddi.datatype.binding.BindingTemplates
          fthpis_bindingTemplates = null;
      if (axis_bindingtemplates != null) {
          cgl.axis.services.uddi.uddi_schema.BindingTemplate[]
                  axis_template_array =
                          axis_bindingtemplates.getBindingTemplate();
          if (axis_template_array != null) {
              java.util.Vector bindingTemplatesVector = new java.util.Vector();
              fthpis_bindingTemplates = new org.apache.juddi.datatype.binding.
                                       BindingTemplates();

              org.apache.juddi.datatype.binding.BindingTemplate template = null;

              int template_size = axis_template_array.length;

              for (int k = 0; k < template_size; k++) {
                  template = new org.apache.juddi.datatype.binding.
                             BindingTemplate();

                  String accesspoint_url_value = axis_template_array[k].
                                                 getAccessPoint().getValue();
                  String accesspoint_url_type = axis_template_array[k].
                                                getAccessPoint().getUseType();
                  org.apache.juddi.datatype.binding.AccessPoint access_point =
                          new org.apache.juddi.datatype.binding.AccessPoint();
                  access_point.setURL(accesspoint_url_value);
                  access_point.setURLType(accesspoint_url_type);

                  //construct template description vector
                  java.util.Vector descVec =
                          constructFTHPIS_DescVector(axis_template_array[k].
                          getDescription());
                  //construct template category bag
                  org.apache.juddi.datatype.CategoryBag categoryBag =
                          constructFTHPIS_CategoryBag(axis_template_array[k].
                          getCategoryBag());
                  template.setAccessPoint(access_point);
                  template.setCategoryBag(categoryBag);
                  template.setDescriptionVector(descVec);
                  bindingTemplatesVector.add(template);
              }
              fthpis_bindingTemplates.setBindingTemplateVector(
                      bindingTemplatesVector);
          }
      }
      return fthpis_bindingTemplates;
    }

    public String getOGCCategory(org.apache.juddi.datatype.CategoryBag
                                 categoryBag) {
      String ogcCategory = null;
      if (categoryBag != null) {
        //find ogc service taxonomy tmodelkey
        String tmodelkey = "65bee600-f1c1-11d6-b493-b8a03c50a862";
        //check all service categories with taxonomy tmodelkey to
        //find the corresponding ogcservice type
        java.util.Vector keyRefVector = categoryBag.getKeyedReferenceVector();
        for (java.util.Iterator iter = keyRefVector.iterator(); iter.hasNext(); ) {
          org.apache.juddi.datatype.KeyedReference kr =
              (org.apache.juddi.datatype.KeyedReference) iter.next();
          //if (kr.getTModelKey().equals(tmodelkey)) {
            if (kr.getKeyValue().equals("WFS")) {
              ogcCategory = "WFS";
            }
            else if (kr.getKeyValue().equals("WMS")) {
              ogcCategory = "WMS";
            }
            else if (kr.getKeyValue().equals("WCS")) {
              ogcCategory = "WCS";
            }
            else if (kr.getKeyValue().equals("WRS")) {
              ogcCategory = "WRS";
            }
          //}
        }
      }
      return ogcCategory;
    }

    public String getAccessPoint(cgl.axis.services.uddi.uddi_schema.BindingTemplates axis_bindingtemplates) {
      String accesspoint_url_value = "";
      cgl.axis.services.uddi.uddi_schema.BindingTemplate[] axis_template_array =
          axis_bindingtemplates.getBindingTemplate();
      if (axis_template_array != null) {
        int template_size = axis_template_array.length;
        for (int k = 0; k < template_size; k++) {
          accesspoint_url_value = axis_template_array[k].getAccessPoint().getValue();
        }
      }
      return accesspoint_url_value;
  }

}
