package cgl.axis.services.uddi_wscontext;

import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;

import cgl.axis.services.uddi.uddi_schema.*;
import cgl.axis.services.uddi.uddi_ext_schema.*;
import cgl.axis.services.WSCTX.uddi_wsctx_schema.*;

import org.apache.axis.types.URI;
import java.util.Vector;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Iterator;

import cgl.util.BootStrap;
import cgl.axis.services.uddi_extended.stubs.*;
import cgl.fthpis.registry.FTHPISRegistryEngine;
import cgl.axis.services.uddi_extended.UDDI_Extended_Helper;
import cgl.notifier.ContextPublisher;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author Mehmet Aktas maktas@indiana.edu
 * @version 1.0
 */

public class UDDI_WSContext {

    // private reference to UDDI_CONTEXT Logger
    private static Log log = LogFactory.getLog(UDDI_WSContext.class);
    private FTHPISRegistryEngine fthpis_engine = null;
    private UDDI_WSContext_Helper uddi_wscontext_helper = null;
    private UDDI_Extended_Helper uddi_extend_helper = null;
    private Properties props = null;
    private ContextPublisher cp = null;

    /**
     *
     */
    public UDDI_WSContext() {
        //RegistryEngine Inisialization
        props = new Properties();
        try {
            props = BootStrap.loadProperties("properties.properties");
        } catch (Exception ex) {
            log.info("Error in loading Property file. " +
                     ex.getMessage());
            System.exit(1);
        }

        uddi_wscontext_helper = new UDDI_WSContext_Helper();
        uddi_extend_helper = new UDDI_Extended_Helper();

        try {
            fthpis_engine = new FTHPISRegistryEngine(props);
            fthpis_engine.init();
        } catch (Exception ex) {
            log.warn(ex.toString());
        }
    }

    ///////////FOLLOWING FUNCTIONS ARE WSCONTEXT FUNCTIONS//////////////////////
    /**
     *
     */
    public AuthToken get_authToken(Get_authToken body) throws DispositionReport {

        cgl.axis.services.uddi.uddi_schema.AuthToken t = null;
        if (body != null) {
            if (body.getUserID() != null && body.getUserID() != null) {
                t = new cgl.axis.services.uddi.uddi_schema.AuthToken();
                log.info("body.getUserID = " + body.getUserID() +
                         " body.getCred = " + body.getCred());

                try {
                    cgl.fthpis.datatype.response.AuthToken token =
                            fthpis_engine.getAuthTokenForWSContext(body.
                            getUserID(), body.getCred());

                    fthpis_engine.dispose();
                    cgl.fthpis.datatype.request.AuthInfo info =
                            token.getAuthInfo();
                    cgl.axis.services.uddi.uddi_schema.AuthInfo authInfo =
                            new cgl.axis.services.uddi.uddi_schema.AuthInfo();
                    authInfo.setValue(info.getValue());
                    authInfo.setPublisherID(info.getPublisherID());
                    t.setAuthInfo(authInfo);
                } catch (Exception ex) {
                    ex.printStackTrace();
                    DispositionReport fault = new DispositionReport();
                }
            }
        }
        return t;
    }

    /**
     *
     */
    public DispositionReport discard_authToken(Discard_authToken body) throws
            DispositionReport {
        DispositionReport fault = null;
        cgl.fthpis.datatype.request.AuthInfo authInfo = null;
        if (body != null) {
            if (body.getAuthInfo() != null) {
                authInfo = new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                authInfo.setValue(info.getValue());
                try {
                    fthpis_engine.discardAuthToken(authInfo);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    ex.printStackTrace();
                    fault = new DispositionReport();
                }
            }
        }
        return fault;
    }

    /**
     *
     */
    public SessionDetail get_sessionDetail(Get_sessionDetail body) throws
            DispositionReport {
        SessionDetail sessionDetail = null;
        if (body != null) {
            //log.info("get_sessionDetail => debug point 0");
            URI[] sessionKey_array = body.getSessionKey();
            if (sessionKey_array != null) {
                //log.info("get_sessionDetail => debug point 1");
                cgl.fthpis.datatype.response.SessionDetail juddi_sessionDetail = null;
                cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());
                //log.info("get_sessionDetail => debug point 2");
                sessionDetail = new SessionDetail();
                SessionEntity[] sessionArray = null;
                Vector sessionKeyVector = null;
                    sessionKeyVector = new Vector();
                    if (sessionKey_array != null) {
                        for (int i = 0; i < sessionKey_array.length; i++) {
                            String sessionKey = sessionKey_array[i].toString();
                            sessionKeyVector.add(sessionKey);
                        }
                    }
                try {
                    juddi_sessionDetail =
                            fthpis_engine.getSessionDetail(juddi_authinfo,
                            sessionKeyVector);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                try {

                    Vector juddi_sessionVector = juddi_sessionDetail.
                                                 getSessionEntityVector();
                    int size = juddi_sessionVector.size();
                    sessionArray = new SessionEntity[size];

                    int service_count = 0;
                    for (Iterator iter = juddi_sessionVector.iterator();
                                         iter.hasNext(); ) {
                        cgl.fthpis.datatype.session.SessionEntity juddi_session =
                                (cgl.fthpis.datatype.session.SessionEntity)
                                iter.next();

                        //log.info("get_sessionDetail => debug point VII");
                        //CONSTRUCT NAME VECTOR
                        Vector nameVec = juddi_session.getNameVector();
                        Name[] axis_name_array = null;
                        if (nameVec != null) {
                            axis_name_array = uddi_wscontext_helper.
                                              constructAXIS_Name(nameVec);
                        }
                        //CONSTRUCT DESCRIPTION VECTOR
                        Vector serviceDescVec = juddi_session.
                                                getDescriptionVector();
                        Description[] axis_desc_array = null;
                        if (serviceDescVec != null) {
                            //log.info(
                            //        "get_sessionDetail => debug point => serviceDescVec");
                            axis_desc_array = uddi_wscontext_helper.
                                              constructAXIS_Description(
                                    serviceDescVec);
                        }

                        //CONSTRUCT AXIS LEASE
                        cgl.fthpis.datatype.lease.Lease juddiLease =
                                juddi_session.getLease();
                        Lease axis_lease = null;
                        if (juddiLease != null) {
                            axis_lease = uddi_wscontext_helper.
                                         constructAXIS_Lease(juddiLease);
                        }

                        //CONSTRUCT AXIS METADATABAG
                        cgl.fthpis.datatype.attribute.AttributeBag cbag =
                                juddi_session.getContextBag();
                        ContextBag contextbag = null;
                        if (cbag != null) {
                            Vector juddi_attributeVector = cbag.
                                    getAttributeVector();
                            if (juddi_attributeVector != null) {
                                contextbag = uddi_wscontext_helper.
                                             constructAXIS_ContextBag(
                                        juddi_attributeVector);
                            }
                        }

                        //set sessionkey
                        String sessionkey = juddi_session.getSessionKey();
                        URI skey = new URI(sessionkey);

                        SessionEntity axis_session = new SessionEntity();

                        axis_session.setSessionKey(skey);
                        axis_session.setName(axis_name_array);
                        axis_session.setDescription(axis_desc_array);
                        axis_session.setLease(axis_lease);
                        axis_session.setContextBag(contextbag);

                        sessionArray[service_count] = axis_session;
                        service_count++;
                    }
                    sessionDetail.setSessionEntity(sessionArray);
                    //log.info("End of function of getSessionDetails..");
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return sessionDetail;

    }

    /**
     *
     */
    public SessionDetail save_session(Save_session body) throws
            DispositionReport {
        SessionDetail axis_sessionDetail = null;
        if (body != null) {
            SessionEntity[] session_entities = body.getSessionEntity();
            if (session_entities != null) {
                cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());
                //log.info("auth info = " + body.getAuthInfo());

                Vector entities = null;

                if (session_entities != null) {
                    axis_sessionDetail = new SessionDetail();
                    try {
                        entities = new Vector();
                        for (int i = 0; i < session_entities.length; i++) {
                            SessionEntity sessionEntity = session_entities[i];

                            //creating vector of Name Object
                            Name[] name_array = sessionEntity.getName();
                            Vector juddi_nameVector = uddi_wscontext_helper.
                                    constructFTHPIS_NameVector(name_array);

                            //creating vector of Description Object
                            Description[] description_array = sessionEntity.
                                    getDescription();
                            Vector juddi_descVector = uddi_wscontext_helper.
                                    constructFTHPIS_DescVector(description_array);

                            //creating Lease for the session
                            Lease lease = sessionEntity.getLease();

                            cgl.fthpis.datatype.lease.Lease juddi_lease =
                                    uddi_wscontext_helper.constructFTHPIS_Lease(
                                            lease);

                            ContextBag contextBag = sessionEntity.getContextBag();
                            cgl.fthpis.datatype.attribute.AttributeBag
                                    juddi_contextBag = null;
                            if (contextBag != null) {
                                Context[] context_arr = contextBag.getContext();
                                if (context_arr != null &&
                                    context_arr.length != 0) {
                                    juddi_contextBag = uddi_wscontext_helper.
                                            constructFTHPIS_ContextBag(
                                            context_arr, info.getPublisherID());
                                }
                            }
                            //create session entitity
                            cgl.fthpis.datatype.session.SessionEntity
                                    session_entity = new cgl.fthpis.datatype.
                                    session.SessionEntity();

                            //set session_key
                            String session_key = session_entity.getSessionKey();
                            if (session_key != null) {
                                session_entity.setSessionKey(session_key);
                            }

                            session_entity.setNameVector(juddi_nameVector);
                            session_entity.setDescriptionVector(
                                    juddi_descVector);
                            session_entity.setContextBag(juddi_contextBag);
                            session_entity.setLease(juddi_lease);
                            entities.add(session_entity);
                        }

                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }

                    // Save session
                    cgl.fthpis.datatype.response.SessionDetail
                            juddi_sessionDetail = null;
                    try {
                        juddi_sessionDetail = fthpis_engine.saveSession(
                                juddi_authinfo, entities);
                        fthpis_engine.dispose();
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                    try {
                        if (juddi_sessionDetail != null) {
                            Vector sessionEntityVector = juddi_sessionDetail.
                                    getSessionEntityVector();
                            int size = sessionEntityVector.size();
                            SessionEntity[] axis_entity_array = new
                                    SessionEntity[size];
                            int i = 0;
                            for (Iterator iter = sessionEntityVector.iterator();
                                                 iter.hasNext(); ) {
                                cgl.fthpis.datatype.session.SessionEntity
                                        juddi_session_entity = (cgl.fthpis.
                                        datatype.session.SessionEntity) iter.
                                        next();

                                SessionEntity axis_session_entity = new
                                        SessionEntity();

                                //set session_key
                                String session_key = juddi_session_entity.
                                        getSessionKey();
                                //log.info("session_key = " + session_key);
                                URI s_key = new URI(session_key);
                                axis_session_entity.setSessionKey(s_key);

                                //set name vector
                                Vector juddi_nameVec = juddi_session_entity.
                                        getNameVector();
                                Name[] name_array = uddi_wscontext_helper.
                                        constructAXIS_Name(juddi_nameVec);
                                axis_session_entity.setName(name_array);

                                //set description vector in session
                                Vector descVec = juddi_session_entity.
                                                 getDescriptionVector();
                                Description[] description_array =
                                        uddi_wscontext_helper.
                                        constructAXIS_Description(descVec);
                                axis_session_entity.setDescription(
                                        description_array);

                                //set lease for the session
                                cgl.fthpis.datatype.lease.Lease juddi_lease =
                                        juddi_session_entity.getLease();
                                if (juddi_lease != null) {
                                    Lease axis_lease = uddi_wscontext_helper.
                                            constructAXIS_Lease(juddi_lease);
                                    axis_session_entity.setLease(axis_lease);
                                }
                                //set the contextBag for the session
                                cgl.fthpis.datatype.attribute.AttributeBag
                                        juddi_contextBag =
                                                juddi_session_entity.
                                                getContextBag();
                                if (juddi_contextBag != null) {
                                    Vector context_vec = juddi_contextBag.
                                            getAttributeVector();
                                    ContextBag contextBag =
                                            uddi_wscontext_helper.
                                            constructAXIS_ContextBag(
                                            context_vec);
                                    axis_session_entity.setContextBag(
                                            contextBag);
                                }
                                axis_entity_array[i] = axis_session_entity;
                                i++;
                            }
                            axis_sessionDetail.setSessionEntity(
                                    axis_entity_array);
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }
        }
        return axis_sessionDetail;
    }

    /**
     *
     */
    public SessionList find_session(Find_session body) throws DispositionReport {
        //log.info("find service function = > debug point -1");
        SessionList axis_sessionList = null;
        if (body != null) {
            cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                    new cgl.fthpis.datatype.request.AuthInfo();
            cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.getAuthInfo();
            juddi_authinfo.setValue(info.getValue());
            juddi_authinfo.setPublisherID(info.getPublisherID());

            //log.info("find service function = > debug point I");
            axis_sessionList = new SessionList();
            cgl.fthpis.datatype.response.SessionList juddi_sessionList =
                    new cgl.fthpis.datatype.response.SessionList();

            Name[] name_array = body.getName();
            //log.info("find service function = > debug point II");
            ContextBag contextbag = body.getContextBag();
            //log.info("find service function = > debug point III");
            Context[] axis_context_array = null;
            if (contextbag != null) {
                axis_context_array = contextbag.getContext();
            }
            //log.info("find service function = > debug point III-I");
            Lease axis_lease = body.getLease();
            FindQualifiers axis_findqualifiers = body.getFindQualifiers();

            int max_rows = 0;
            Vector namesVector = null;
            org.apache.juddi.datatype.request.FindQualifiers
                    juddi_findQualifiers = null;
            cgl.fthpis.datatype.attribute.AttributeBag contextBag = null;
            cgl.fthpis.datatype.lease.Lease juddi_lease = null;
            //log.info("find service function = > debug point IV");
            try {
                //log.info("debug point V");
                //HOW MANY RESULTS
                max_rows = body.getMaxRows();

                //CONSTRUCT NAME VECTOR
                namesVector = uddi_wscontext_helper.
                              constructFTHPIS_NameVector(
                                      name_array);

                //log.info("debug point VI");

                //CONSTRUCT FINDQUALIFIERS
                juddi_findQualifiers = uddi_wscontext_helper.
                                       constructFTHPIS_FindQualifiers(
                                               axis_findqualifiers);

                //log.info("debug point VII");

                //CONSTRUCT METADATABAG
                contextBag = uddi_wscontext_helper.
                             constructFTHPIS_ContextBag(
                                     axis_context_array, info.getPublisherID());

                //log.info("debug point IX");

                //CONSTRUCT LEASE OBJECT
                juddi_lease = uddi_wscontext_helper.constructFTHPIS_Lease(
                        axis_lease);

            } catch (Exception ex) {
                ex.printStackTrace();
            }

            //log.info("debug point X");
            try {
                juddi_sessionList = fthpis_engine.findSession(
                        juddi_authinfo,
                        namesVector,
                        contextBag,
                        null,
                        juddi_lease,
                        juddi_findQualifiers,
                        max_rows);
                fthpis_engine.dispose();

            } catch (Exception ex) {
                ex.printStackTrace();
            }
            try {

                //log.info("debug point XI");
                if (juddi_sessionList != null) {
                    cgl.fthpis.datatype.response.SessionInfos
                            juddi_sessioninfos = juddi_sessionList.
                                                 getSessionInfos();
                    //log.info("debug point XII");
                    if (juddi_sessioninfos != null) {
                        Vector sessioninfovector = juddi_sessioninfos.
                                getSessionInfoVector();
                        //log.info("debug point XIII");
                        SessionInfos axis_session_infos = new SessionInfos();
                        if (sessioninfovector != null) {
                            SessionInfo[] axis_session_info_array =
                                    new SessionInfo[sessioninfovector.size()];
                            //log.info("debug point XIV");
                            int count = 0;
                            for (Iterator iter = sessioninfovector.iterator();
                                                 iter.hasNext(); ) {
                                cgl.fthpis.datatype.response.SessionInfo
                                        juddi_sessioninfo = (cgl.fthpis.
                                        datatype.response.SessionInfo) iter.
                                        next();
                                SessionInfo axis_session_info = new SessionInfo();
                                //log.info("debug point XV");
                                //CONSTRUCT AXIS SESSION KEY
                                axis_session_info.setSessionKey(new URI(
                                        juddi_sessioninfo.getSessionKey()));
                                axis_session_info.setName(uddi_wscontext_helper.
                                        constructAXIS_Name(juddi_sessioninfo.
                                        getNameVector()));

                                axis_session_info_array[count] =
                                        axis_session_info;
                                count++;
                            }
                            axis_session_infos.setSessionInfo(
                                    axis_session_info_array);
                        }
                        axis_sessionList.setSessionInfos(axis_session_infos);
                    }
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return axis_sessionList;
    }

    /**
     *
     */
    public DispositionReport delete_session(Delete_session body) throws
            DispositionReport {
        //log.info("delete_session I");
        DispositionReport fault = null;
        if (body != null) {
            URI[] session_key_array = body.getSessionKey();
            if (session_key_array != null) {
                Vector session_vector = new Vector();
                org.apache.juddi.datatype.response.DispositionReport dr = null;
                cgl.fthpis.datatype.request.AuthInfo
                        authinfo = new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                authinfo.setValue(info.getValue());
                authinfo.setPublisherID(info.getPublisherID());
                //log.info("delete_session = " + body.getAuthInfo());
                if (session_key_array != null) {
                    for (int i = 0; i < session_key_array.length; i++) {
                        URI axis_session_key =
                                session_key_array[i];
                        if (axis_session_key != null) {
                            String key = session_key_array[i].toString();
                            //log.info("session key = " + key);
                            session_vector.add(key);
                        }
                    }
                    //log.info("delete_session function before deletion....");
                    fault = new DispositionReport();
                    try {
                        dr = fthpis_engine.deleteSession(authinfo,
                                session_vector);
                        fthpis_engine.dispose();

                        Vector resultvector = dr.getResultVector();
                        if (resultvector != null) {
                            Result[] axis_result_array =
                                    new Result[
                                    resultvector.size()];
                            int i = 0;
                            for (Iterator iter = resultvector.iterator();
                                                 iter.hasNext(); ) {
                                org.apache.juddi.datatype.response.Result
                                        result = (org.apache.juddi.datatype.
                                                  response.Result) iter.next();
                                int errno = result.getErrno();
                                Result axis_result = new Result();
                                result.setErrno(errno);
                                axis_result_array[i] = axis_result;
                                i++;
                            }
                            fault.setResult(axis_result_array);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        fault = new DispositionReport();
                    } finally {
                        fault = new DispositionReport();

                        if (dr.getResultVector() != null ||
                            dr.getResultVector().size() != 0) {
                            Vector results = dr.getResultVector();
                            for (int j = 0; j < results.size(); j++) {
                                org.apache.juddi.datatype.response.Result
                                        r = (org.apache.juddi.datatype.response.
                                             Result) results.elementAt(j);
                                // log.info("\nerr_info:" + r.getErrInfo());
                                fault.setFaultString("\n errno: " + r.getErrno());
                            }
                        }
                    }
                }
            }
        }
        return fault;
    }

    /**
     *
     */
    public ContextDetail get_contextDetail(Get_contextDetail body) throws
            DispositionReport {
        ContextDetail contextDetail = null;
        if (body != null) {
            URI[] contextKey_array = body.getContextKey();
            if (contextKey_array != null) {
                cgl.fthpis.datatype.response.AttributeDetail
                        juddi_contextDetail = null;
                contextDetail = new ContextDetail();
                Vector contextKeyVector = null;
                cgl.fthpis.datatype.request.AuthInfo
                        authinfo = new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                authinfo.setValue(info.getValue());
                authinfo.setPublisherID(info.getPublisherID());
                 contextKeyVector = new Vector();
                    if (contextKey_array != null) {
                        for (int i = 0; i < contextKey_array.length; i++) {
                            String contextkey = contextKey_array[i].toString();
                            contextKeyVector.add(contextkey);
                        }
                    }
                    try {
                        juddi_contextDetail =
                                fthpis_engine.getContextDetail(authinfo,
                                contextKeyVector);
                        fthpis_engine.dispose();
                    } catch (Exception ex2) {
                        ex2.printStackTrace();
                    }

                if (juddi_contextDetail != null) {
                    Vector juddi_contextVector = juddi_contextDetail.
                                                 getContextVector();
                    try {
                        if (juddi_contextVector != null &&
                            juddi_contextVector.size() != 0) {
                            ContextBag contextbag =
                                    uddi_wscontext_helper.
                                    constructAXIS_ContextBag(
                                            juddi_contextVector);
                            contextDetail.setContextBag(contextbag);
                            //log.info(
                            //        "I finished the function of getServiceAttributeDetails....");
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }
        }
        return contextDetail;

    }

    /**
     *
     */
    public ContextDetail save_context(Save_context body) throws
            DispositionReport {
        ContextDetail axis_contextDetail = null;
        if (body != null) {
            ContextBag contextbag = body.getContextBag();
            if (contextbag != null) {
                cgl.fthpis.datatype.request.AuthInfo
                        juddi_authinfo = new cgl.fthpis.datatype.request.
                                         AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());

                Vector contextvector = null;
                axis_contextDetail = new ContextDetail();
                Context[] axis_context_array = contextbag.getContext();
                if (axis_context_array != null) {
                        contextvector = new Vector();
                        cgl.fthpis.datatype.attribute.AttributeBag contextBag =
                                uddi_wscontext_helper.constructFTHPIS_ContextBag(
                                        axis_context_array, info.getPublisherID());
                        contextvector = contextBag.getAttributeVector();
                }

                cgl.fthpis.datatype.response.AttributeDetail contextDetail = null;
                //////////////////////////////////////////////////////////////////////////
                try {
                    contextDetail = fthpis_engine.saveContext(
                            juddi_authinfo,
                            contextvector);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    log.info("Oups. Couldnt' SET the context in the DataBase." + ex.getMessage());
                }
                //////////////////////////////////////////////////////////////////////////

                try {
                    if (contextDetail != null) {
                        Vector propVector = contextDetail.getContextVector();
                        int prop_count = 0;
                        if (propVector != null && propVector.size() != 0) {
                            for (Iterator iter = propVector.iterator();
                                                 iter.hasNext(); ) {
                                cgl.fthpis.datatype.attribute.Attribute prop =
                                        (cgl.fthpis.datatype.attribute.
                                         Attribute) iter.next();
                                Context context = axis_context_array[prop_count];
                                //serviceAttribute key
                                String contextKey = prop.getAttributeKey();
                                //contextKey = "uuid:" + contextKey;
                                URI serviceAttributeKey = new URI(contextKey);
                                context.setContextKey(serviceAttributeKey);

//                                //THIS IS NOTIFICATION FEATURE
//                                //EVERYTIME CONTEXT IS SAVED THIS SHOULD BE PUBLISHED TO
//                                //ITS SESSION KEY
//                                //publish update or adding the message
//                                if (context.getSessionKey() != null) {
//                                    //this is to hightlight the type of the operation
//                                    context.setValueType("add/update");
//                                    String topic = "/" + context.getSessionKey();
//                                    try {
//                                        cp.publishMessage(topic, context);
//                                        log.info(
//                                                "###### Context is published properly ######");
//                                    } catch (Exception ex) {
//                                        //ex.printStackTrace();
//                                        log.info(
//                                                "###### Publishing message could not completed!!! ######");
//                                    }
//                                }
                                axis_context_array[prop_count] = context;
                                prop_count++;
                            }
                        }
                        ContextBag context_bag = new ContextBag();
                        context_bag.setContext(axis_context_array);
                        axis_contextDetail.setContextBag(context_bag);
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return axis_contextDetail;

    }

    /**
     *
     */
    public ContextList find_context(Find_context body) throws DispositionReport {
        ContextList contextlist = null;
        if (body != null) {
            URI axis_sessionkey = body.getSessionKey();
            String servicekey = null, sessionkey = null,
                    updated_servicekey = null;
            cgl.fthpis.datatype.response.AttributeList juddi_contextlist = null;
            Vector juddi_nameVector = null;
            org.apache.juddi.datatype.request.FindQualifiers
                    juddi_findqualifiers = null;
            cgl.fthpis.datatype.lease.Lease juddi_lease = null;
            cgl.fthpis.datatype.request.AuthInfo juddi_authinfo = new
                    cgl.fthpis.datatype.request.AuthInfo();

            cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.getAuthInfo();
            juddi_authinfo.setValue(info.getValue());
            juddi_authinfo.setPublisherID(info.getPublisherID());

            contextlist = new ContextList();
            URI axis_servicekey = body.getServiceKey();
            Name[] name_array = body.getName();
            FindQualifiers axis_find_qualifiers = body.getFindQualifiers();
            Lease axis_lease = body.getLease();
            int max_rows = body.getMaxRows();

            try {
                if (axis_sessionkey != null) {
                    sessionkey = axis_sessionkey.toString();
                }
                if (axis_servicekey != null) {
                    servicekey = axis_servicekey.toString();
                    StringTokenizer service_tokenizer = new StringTokenizer(
                            servicekey, "uuid:");
                    updated_servicekey = service_tokenizer.nextToken();
                }

                //CONSTRUCT NAME VECTOR
                if (name_array != null) {
                    juddi_nameVector = uddi_wscontext_helper.
                                       constructFTHPIS_NameVector(
                                               name_array);
                }
                if (axis_find_qualifiers != null) {
                    juddi_findqualifiers = uddi_wscontext_helper.
                                           constructFTHPIS_FindQualifiers(
                            axis_find_qualifiers);
                }
                if (axis_lease != null) {
                    juddi_lease = uddi_wscontext_helper.
                                  constructFTHPIS_Lease(axis_lease);
                }

                try {
                    juddi_contextlist = fthpis_engine.findContext(
                            juddi_authinfo,
                            sessionkey,
                            updated_servicekey,
                            juddi_nameVector,
                            juddi_lease,
                            juddi_findqualifiers, max_rows);
                    fthpis_engine.dispose();
                    //log.info(
                    //        "After finishing the function of find_context =>  I  ");
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                if (juddi_contextlist != null) {
                    cgl.fthpis.datatype.response.AttributeInfos infos =
                            juddi_contextlist.getAttributeInfos();
                    if (infos != null &&
                        infos.getAttributeInfoVector() != null) {
                        Vector attributeInfoVector = infos.
                                getAttributeInfoVector();

                        ContextInfos contextinfos = new ContextInfos();
                        ContextInfo[] contextinfo_array =
                                new ContextInfo[attributeInfoVector.size()];
                        ContextInfo contextinfo = null;
                        int count = 0;
                        for (Iterator iter = attributeInfoVector.iterator();
                                             iter.hasNext(); ) {
                            cgl.fthpis.datatype.response.AttributeInfo
                                    attribute_info =
                                            (cgl.fthpis.datatype.response.
                                             AttributeInfo) iter.next();
                            //context_key
                            contextinfo = new ContextInfo();
                            //contextinfo.setContextKey(new URI("uuid:" +
                            //          attribute_info.getAttributeKey()));
                            contextinfo.setContextKey(new URI(
                                    attribute_info.getAttributeKey()));
                            contextinfo.setName(uddi_wscontext_helper.
                                                constructAXIS_Name(
                                    attribute_info.getNameVector()));
                            contextinfo_array[count] = contextinfo;
                            count++;
                        }
                        //log.info(
                        //        "I finished the function of find_serviceAttribute =>  II ");
                        //log.info("contextinfo_array size = " +
                        //         contextinfo_array.length);
                        contextinfos.setContextInfo(contextinfo_array);
                        contextlist.setContextInfos(contextinfos);
                    }
                }

            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return contextlist;
    }

    /**
     *
     */
    public DispositionReport delete_context(Delete_context body) throws
            DispositionReport {
        DispositionReport fault = null;
        org.apache.juddi.datatype.response.DispositionReport dr = null;
        ///////////////////////////////////////
        if (body != null) {
            URI[] contextkey_array = body.getContextKey();
            if (contextkey_array != null && contextkey_array.length != 0) {
                cgl.fthpis.datatype.response.AttributeDetail
                        juddi_contextDetail = null;
                Vector contextKeyVector = null;
                cgl.fthpis.datatype.request.AuthInfo
                        juddi_authinfo = new cgl.fthpis.datatype.request.
                                         AuthInfo();
                AuthInfo info = body.getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());
                try {
                    contextKeyVector = new Vector();
                    if (contextkey_array != null) {
                        for (int i = 0; i < contextkey_array.length; i++) {
                            String contextkey = contextkey_array[i].toString();
                            contextKeyVector.add(contextkey);
                        }
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
//                ////////////////////////////////////////////////////////////////
//                try {
//                    juddi_contextDetail =
//                            fthpis_engine.getContextDetail(juddi_authinfo,
//                            contextKeyVector);
//                    fthpis_engine.dispose();
//                } catch (Exception ex) {
//                    ex.printStackTrace();
//                }
//                try {
//                    Vector juddi_contextVector = juddi_contextDetail.
//                                                 getContextVector();
//                    if (juddi_contextVector != null) {
//                       ContextBag contextbag =
//                                uddi_wscontext_helper.constructAXIS_ContextBag(
//                                        juddi_contextVector);
//                        if (contextbag != null && contextbag.getContext() != null &&
//                            contextbag.getContext().length != 0) {
//                            Context[] context_arr = contextbag.getContext();
//                            //EVERYTIME A CONTEXT IS DELETED THIS INFO IS PUBLISHED TO THE
//                            //SESSION THAT CONTEXT BELOGS TO
//                            for (int i = 0; i < context_arr.length; i++) {
//                                Context context = context_arr[i];
//                                //publish update or adding the message message
//                                if (context != null && context.getSessionKey() != null) {
//                                    //this is to hightlight the type of the operation
//                                    context.setValueType("delete");
//                                    String topic = "/" + context.getSessionKey();
//                                    try {
//                                        cp.publishMessage(topic, context);
//                                        log.info(
//                                                "###### Context is published properly ######");
//                                    } catch (Exception ex) {
//                                        //ex.printStackTrace();
//                                        log.info(
//                                                "###### Publishing message could not completed!!! ######");
//                                    }
//                                }
//                            }
//                        }
//                    }
//                } catch (Exception ex) {
//                    ex.printStackTrace();
//                }
//                ////////////////////////////////////////////////////////////////
                fault = new DispositionReport();
                try {
                    dr = fthpis_engine.deleteContext(juddi_authinfo,
                            contextKeyVector);
                    fthpis_engine.dispose();
                    Vector resultvector = dr.getResultVector();
                    if (resultvector != null) {
                        Result[] axis_result_array = new Result[resultvector.
                                size()];
                        int i = 0;
                        for (Iterator iter = resultvector.iterator();
                                             iter.hasNext(); ) {
                            org.apache.juddi.datatype.response.Result
                                    result = (org.apache.juddi.datatype.
                                              response.Result) iter.next();
                            int errno = result.getErrno();
                            log.info("error no = " + errno);
                            log.info("error message = " + result.getErrInfo());
                            Result axis_result = new Result();
                            result.setErrno(errno);
                            axis_result_array[i] = axis_result;
                        }
                        fault.setResult(axis_result_array);
                    }
                } catch (Exception e) {
                    try {
                        log.warn("UDDIException faultCode: " + e);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        fault = new
                                DispositionReport();
                    }
                }
            }
        }
        return fault;
    }

    /**
     *
     */
    private UDDI_ExtendedSoapBindingStub getbinding() {
        UDDI_ExtendedSoapBindingStub binding = null;
        try {
            UDDI_ExtendedServiceLocator locator = new
                                                  UDDI_ExtendedServiceLocator();
            locator.setEndpointAddress("UDDI_Extended",
                                       props.
                                       getProperty("UDDI_Extended_WSDL"));
            log.info(props.getProperty("UDDI_Extended_WSDL"));
            binding = (UDDI_ExtendedSoapBindingStub) locator.
                      getUDDI_Extended();
        } catch (javax.xml.rpc.ServiceException jre) {
            if (jre.getLinkedCause() != null) {
                jre.getLinkedCause().printStackTrace();
            }
            throw new junit.framework.AssertionFailedError(
                    "JAX-RPC ServiceException caught: " + jre);
        }
        return binding;
    }

    ///////FOLLOWING WILL FUNCTIONS WILL FORWARD IT TO WSCONTEXT AND UDDI////////
    /**
     *
     */
    public cgl.axis.services.uddi.uddi_ext_schema.ServiceDetail save_service(
            cgl.axis.services.uddi.uddi_ext_schema.Save_service body) throws
            DispositionReport {
        cgl.axis.services.uddi.uddi_ext_schema.ServiceDetail axis_serviceDetail = null;
        if (body != null) {
            cgl.axis.services.uddi.uddi_ext_schema.BusinessService[]
                    axis_business_service_array = body.getBusinessService();
            if (axis_business_service_array != null) {
                ////////////////////////////////////////////////////////////////////////

                UDDI_ExtendedSoapBindingStub binding = null;
                binding = getbinding();
                axis_serviceDetail = new cgl.axis.services.uddi.uddi_ext_schema.
                                     ServiceDetail();

                cgl.axis.services.uddi.uddi_ext_schema.ServiceDetail sdetail = null;
                try {
                    sdetail = binding.save_service(body);
                } catch (java.rmi.RemoteException ex) {
                    ex.printStackTrace();
                }
                cgl.axis.services.uddi.uddi_ext_schema.BusinessService[]
                        service_array = sdetail.getBusinessService();
                if (service_array != null) {
                    for (int k = 0; k < service_array.length; k++) {
                        cgl.axis.services.uddi.uddi_ext_schema.BusinessService
                                bservice = service_array[k];
                        cgl.axis.services.uddi.uddi_ext_schema.BusinessService
                                b = axis_business_service_array[k];
                        b.setServiceKey(bservice.getServiceKey());
                        axis_business_service_array[k] = b;
                    }
                }
                ////////////////////////////////////////////////////////////////////////
                log.info("debug point - 1");

                if (body.getAuthInfo() != null) {
                    cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                            new cgl.fthpis.datatype.request.AuthInfo();
                    cgl.axis.services.uddi.uddi_schema.AuthInfo axis_authInfo =
                            body.getAuthInfo();
                    juddi_authinfo.setValue(axis_authInfo.getValue());

                    Vector servicesVector = new Vector();
                    cgl.fthpis.datatype.service.BusinessService service = null;
                    try {
                        if (axis_business_service_array != null) {

                            for (int j = 0;
                                         j < axis_business_service_array.length;
                                         j++) {

                                //CONSTRUCT CONTEXTBAG
                                cgl.fthpis.datatype.attribute.AttributeBag
                                        contextBag = null;
                                ContextBag contextbag =
                                        axis_business_service_array[
                                        j].getContextBag();
                                if (contextbag != null) {
                                    Context[] axis_context_array = contextbag.
                                            getContext();
                                    contextBag = uddi_wscontext_helper.
                                                 constructFTHPIS_ContextBag(
                                            axis_context_array,
                                            axis_authInfo.getPublisherID());
                                }

                                //SET SESSION KEY VECTOR
                                URI[] axis_sessionKey =
                                        axis_business_service_array[
                                        j].getSessionKey();
                                Vector sessionKeyVector = null;
                                if (axis_sessionKey != null) {
                                    sessionKeyVector = new Vector();
                                    for (int i = 0; i < axis_sessionKey.length;
                                                 i++) {
                                        URI axis_sessionkey = axis_sessionKey[i];
                                        if (axis_sessionkey != null) {
                                            String temp = axis_sessionkey.
                                                    toString();
                                            StringTokenizer tokenizer =
                                                    new StringTokenizer(temp,
                                                    "uuid:");
                                            temp = tokenizer.nextToken();
                                            if (temp != null) {
                                                if (!temp.equals("")) {
                                                    String session_key = temp;
                                                    sessionKeyVector.add(
                                                            session_key);
                                                }
                                            }
                                        }
                                    }
                                    service.setSessionKeyVector(
                                            sessionKeyVector);
                                    service.setDynamicContextBag(contextBag);

                                    servicesVector.add(service);
                                }
                            }
                        }
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }

                    /////////////second save the dynamic metadata with serviceKey//////////////////
                    /////servicekey is already determined so we don't need to get serviceKey//
                    ////////////////////////////////////////////////////////////////////////////
                    cgl.fthpis.datatype.response.ServiceDetail
                            staticMetadataDetail = null;
                    try {
                        fthpis_engine.saveFTHPISService(juddi_authinfo,
                                servicesVector);
                        fthpis_engine.dispose();
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
                ////////////////////////////////////////////////////////////////////////
                axis_serviceDetail.setBusinessService(
                        axis_business_service_array);
            }
        }
        return axis_serviceDetail;
    }

    /**
     *
     */
    public ServiceList find_service(cgl.axis.services.uddi.uddi_ext_schema.
                                    Find_service body) throws DispositionReport {
        ServiceList axis_serviceList = null;
        if (body != null) {
            if (body.getAuthInfo() != null) {
                axis_serviceList = new ServiceList();
                Vector service_info_vector = new Vector();
                ////////////////////////////////////////////////////////////////////////
                UDDI_ExtendedSoapBindingStub binding = null;
                binding = getbinding();
                try {
                    axis_serviceList = binding.find_service(body);
                } catch (java.rmi.RemoteException ex) {
                    ex.printStackTrace();
                }
                ServiceInfos infos = axis_serviceList.getServiceInfos();
                if (infos != null) {
                    ServiceInfo[] info_array = infos.getServiceInfo();
                    for (int k = 0; k < info_array.length; k++) {
                        service_info_vector.add(info_array[k]);
                    }
                }
                ////////////////////////////////////////////////////////////////////////
                //log.info("find service function = > debug point 0");
                cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo axis_authInfo =
                        body.getAuthInfo();
                juddi_authinfo.setValue(axis_authInfo.getValue());
                //////////////////////////////////////////////////////////////////////////
                //log.info("find service function = > debug point 1");

                cgl.fthpis.datatype.response.ServiceList juddi_serviceList =
                        new cgl.fthpis.datatype.response.ServiceList();

                URI[] axis_sessionKey_array = body.getSessionKey();

                ContextBag contextBag = body.getContextBag();
                Context[] axis_context_array = null;
                if (contextBag != null) {
                    axis_context_array = contextBag.getContext();
                }

                FindQualifiers axis_findqualifiers = body.getFindQualifiers();

                int max_rows = 0;

                org.apache.juddi.datatype.request.FindQualifiers
                        juddi_findQualifiers = null;

                cgl.fthpis.datatype.attribute.AttributeBag
                        dynamiccontextBag = null;

                Vector sessionKeyVector = null;
                //log.info("find service function = > debug point IV");
                try {

                    //CONSTRUCT SESSIONKEYVECTOR
                    sessionKeyVector = new Vector();
                    for (int i = 0; i < axis_sessionKey_array.length; i++) {
                        String temp_session_key = axis_sessionKey_array[i].
                                                  toString();
                        StringTokenizer token = new StringTokenizer(
                                temp_session_key, "uuid:");
                        temp_session_key = token.nextToken();
                        cgl.fthpis.datatype.SessionKey
                                sessionkey = new cgl.fthpis.datatype.SessionKey();
                        sessionkey.setValue(temp_session_key);
                        sessionKeyVector.add(sessionkey);
                    }

                    //CONSTRUCT FINDQUALIFIERS
                    juddi_findQualifiers = uddi_extend_helper.constructFTHPIS_FindQualifiers(
                            axis_findqualifiers);

                    //CONSTRUCT CONTEXTBAG
                    dynamiccontextBag = uddi_wscontext_helper.
                                        constructFTHPIS_ContextBag(
                                                axis_context_array,
                                                axis_authInfo.getPublisherID());

                } catch (Exception ex) {
                    ex.printStackTrace();
                }

                //log.info("debug point X");
                try {
                    juddi_serviceList = fthpis_engine.findFTHPISService(
                            juddi_authinfo,
                            sessionKeyVector,
                            dynamiccontextBag,
                            juddi_findQualifiers,
                            max_rows);
                    fthpis_engine.dispose();

                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                try {

                    //log.info("debug point XI");
                    if (juddi_serviceList != null) {
                        cgl.fthpis.datatype.response.ServiceInfos
                                juddi_serviceinfos =
                                        juddi_serviceList.getServiceInfos();
                        //log.info("debug point XII");
                        if (juddi_serviceinfos != null) {
                            Vector serviceinfovector = juddi_serviceinfos.
                                    getServiceInfoVector();
                            //log.info("debug point XIII");
                            ServiceInfos axis_service_infos =
                                    new ServiceInfos();
                            if (serviceinfovector != null) {

                                //log.info("debug point XIV");
                                int count = 0;
                                for (Iterator iter = serviceinfovector.
                                        iterator();
                                        iter.hasNext(); ) {
                                    cgl.fthpis.datatype.response.
                                            ServiceInfo
                                            juddi_serviceinfo = (
                                            cgl.fthpis.datatype.response.
                                            ServiceInfo) iter.next();
                                    ServiceInfo axis_service_info = new
                                            ServiceInfo();
                                    //log.info("debug point XV");

                                    //CONSTRUCT AXIS SERVICE KEY
                                    String service_key = juddi_serviceinfo.
                                            getServiceKey();
                                    service_key = "uuid:" + service_key;
                                    URI key = new URI(service_key);
                                    axis_service_info.setServiceKey(key);

                                    service_info_vector.add(
                                            axis_service_info);
                                    count++;
                                }

                                ServiceInfo[] axis_service_info_array =
                                        new ServiceInfo[service_info_vector.
                                        size()];
                                axis_service_info_array = (ServiceInfo[])
                                        service_info_vector.toArray();
                                axis_service_infos.setServiceInfo(
                                        axis_service_info_array);
                            }
                            axis_serviceList.setServiceInfos(
                                    axis_service_infos);
                        }
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return axis_serviceList;
    }

    /**
     *
     */
    public cgl.axis.services.uddi.uddi_ext_schema.ServiceDetail
            get_serviceDetail(Get_serviceDetail body) throws DispositionReport {
        cgl.axis.services.uddi.uddi_ext_schema.ServiceDetail serviceDetail = null;
        if (body != null) {
            URI[] serviceKey_array = body.getServiceKey();
            if (serviceKey_array != null) {
                serviceDetail = new cgl.axis.services.uddi.uddi_ext_schema.
                                ServiceDetail();
                cgl.fthpis.datatype.response.ServiceDetail juddi_serviceDetail = null;
                //log.info("debug point 0");
                java.util.Hashtable table = new java.util.Hashtable();
                ////////////////////////////////////////////////////////////////////////
                UDDI_ExtendedSoapBindingStub binding = null;
                binding = getbinding();
                try {
                    serviceDetail = binding.get_serviceDetail(body);
                } catch (java.rmi.RemoteException ex) {
                    ex.printStackTrace();
                }
                cgl.axis.services.uddi.uddi_ext_schema.BusinessService[]
                        bservices = serviceDetail.getBusinessService();
                for (int i = 0; i < bservices.length; i++) {
                    table.put(bservices[i].getServiceKey(), bservices[i]);
                }

                ////////////////////////////////////////////////////////////////////////
                cgl.fthpis.datatype.request.AuthInfo authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                //////////////////////////////////////////////////////////////////////////

                cgl.axis.services.uddi.uddi_schema.AuthInfo axis_authInfo =
                        body.getAuthInfo();
                authinfo.setValue(axis_authInfo.getValue());
                //////////////////////////////////////////////////////////////////////////
                cgl.axis.services.uddi.uddi_ext_schema.BusinessService[]
                        businessServiceArray = null;
                Vector serviceKeyVector = null;
                try {

                    serviceKeyVector = new Vector();
                    if (serviceKey_array != null) {
                        for (int i = 0; i < serviceKey_array.length; i++) {
                            StringTokenizer tokenizer =
                                    new StringTokenizer(serviceKey_array[i].
                                    toString(), "uuid:");
                            //String first = tokenizer.nextToken();
                            String servicekey = tokenizer.nextToken();
                            //log.info("****** updated businessKey = " +
                            //         servicekey);
                            serviceKeyVector.add(servicekey);
                        }
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                try {
                    juddi_serviceDetail = fthpis_engine.getServiceDetail(
                            authinfo,
                            serviceKeyVector);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                try {

                    Vector juddi_businessServiceVector = juddi_serviceDetail.
                            getBusinessServiceVector();
                    int size = juddi_businessServiceVector.size();

                    businessServiceArray = new cgl.axis.services.uddi.
                                           uddi_ext_schema.BusinessService[size];

                    int service_count = 0;
                    for (Iterator iter = juddi_businessServiceVector.iterator();
                                         iter.hasNext(); ) {
                        cgl.fthpis.datatype.service.BusinessService
                                juddi_service =
                                        (cgl.fthpis.datatype.service.
                                         BusinessService) iter.
                                        next();

                        //set service key
                        String servicekey = juddi_service.getServiceKey();
                        servicekey = "uuid:" + servicekey;
                        URI key = new URI(servicekey);

                        cgl.axis.services.uddi.uddi_ext_schema.BusinessService
                                axis_businessService =
                                        (cgl.axis.services.uddi.uddi_ext_schema.
                                         BusinessService) table.get(key);

                        //set session_key_vector
                        Vector sessionKeyVector = juddi_service.
                                                  getSessionKeyVector();
                        URI[] session_uri_array = new URI[sessionKeyVector.size()];
                        int i = 0;
                        for (Iterator iterator = sessionKeyVector.iterator();
                                                 iterator.hasNext(); ) {
                            cgl.fthpis.datatype.SessionKey sessionKey =
                                    (cgl.fthpis.datatype.SessionKey) iterator.
                                    next();
                            URI skey = new URI("uuid:" + sessionKey.getValue());
                            session_uri_array[i] = skey;
                            i++;
                        }

                        //CONSTRUCT AXIS CONTEXTBAG
                        cgl.fthpis.datatype.attribute.AttributeBag cbag =
                                juddi_service.getAttributeBag();
                        ContextBag contextbag = null;
                        if (cbag != null) {
                            Vector juddi_contextVector = cbag.
                                    getAttributeVector();
                            if (juddi_contextVector != null) {
                                contextbag = uddi_wscontext_helper.
                                             constructAXIS_ContextBag(
                                        juddi_contextVector);
                            }
                        }

                        axis_businessService.setContextBag(contextbag);
                        axis_businessService.setSessionKey(session_uri_array);
                        businessServiceArray[service_count] =
                                axis_businessService;
                        service_count++;
                    }
                    serviceDetail.setBusinessService(businessServiceArray);
                    //log.info("End of function of getServiceDetails..");
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return serviceDetail;
    }

    /**
     *
     */
    public DispositionReport delete_service(Delete_service body) {
        DispositionReport fault = null;
        if (body != null) {
            if (body.getAuthInfo() != null) {
                UDDI_ExtendedSoapBindingStub binding = null;
                binding = getbinding();
                ////////////////////////////////////////////////////////////////////////
                try {
                    binding.delete_service(body);
                } catch (java.rmi.RemoteException ex) {
                    ex.printStackTrace();
                }
                ////////////////////////////////////////////////////////////////////////
                URI[] service_key_array = body.getServiceKey();
                Vector service_vector = new Vector();
                org.apache.juddi.datatype.response.DispositionReport dr = null;

                cgl.fthpis.datatype.request.AuthInfo authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                //////////////////////////////////////////////////////////////////////////

                cgl.axis.services.uddi.uddi_schema.AuthInfo axis_authInfo =
                        body.getAuthInfo();
                authinfo.setValue(axis_authInfo.getValue());
                //////////////////////////////////////////////////////////////////////////
                if (service_key_array != null) {
                    for (int i = 0; i < service_key_array.length; i++) {
                        URI axis_service_key = service_key_array[i];
                        if (axis_service_key != null) {
                            String key = service_key_array[i].toString();
                            StringTokenizer tokenizer = new StringTokenizer(key,
                                    "uuid:");
                            key = tokenizer.nextToken();
                            log.info("key = " + key);
                            service_vector.add(key);
                        }
                    }
                    fault = new DispositionReport();
                    try {
                        dr = fthpis_engine.deleteFTHPISService(authinfo,
                                service_vector);
                        fthpis_engine.dispose();
                        Vector resultvector = dr.getResultVector();
                        if (resultvector != null) {
                            Result[] axis_result_array = new Result[
                                    resultvector.
                                    size()];
                            int i = 0;
                            for (Iterator iter = resultvector.iterator();
                                                 iter.hasNext(); ) {
                                org.apache.juddi.datatype.response.Result
                                        result =
                                                (org.apache.juddi.datatype.
                                                 response.Result)
                                                iter.next();
                                int errno = result.getErrno();
                                Result axis_result = new Result();
                                result.setErrno(errno);
                                axis_result_array[i] = axis_result;
                            }
                            fault.setResult(axis_result_array);
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                        fault = new DispositionReport();
                    }
                }
            }
        }
        return fault;
    }

    ///////////FOLLOWING FUNCTIONS WILL FORWARD REQUESTS TO UDDI////////////////

    /**
     *
     */
    public ServiceAttributeDetail save_serviceAttribute(Save_serviceAttribute
            body) throws DispositionReport {
        ServiceAttributeDetail value = null;

        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();

            Get_authToken get_authtoken = new Get_authToken();
            get_authtoken.setUserID("uddi_user");
            get_authtoken.setCred("changeIt");

            AuthToken token = null;
            try {
                token = binding.get_authToken(get_authtoken);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
            }
            AuthInfo authinfo = token.getAuthInfo();
            //String publisher_id = authinfo.getPublisherID();
            //String publisher_cred = authinfo.getValue();
            //System.out.println("publisher_id = " + publisher_id + " publisher_cred = " + publisher_cred);

            body.setAuthInfo(authinfo);

            //DispositionReport fault = null;
            try {
                value = binding.save_serviceAttribute(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public ServiceAttributeList find_serviceAttribute(Find_serviceAttribute
            body) throws DispositionReport {
        ServiceAttributeList value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();

            //DispositionReport fault = null;
            try {
                value = binding.find_serviceAttribute(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        return value;
    }

    /**
     *
     */
    public ServiceAttributeDetail get_serviceAttributeDetail(
            Get_serviceAttributeDetail body) throws DispositionReport {
        ServiceAttributeDetail value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();
            //DispositionReport fault = null;
            try {
                value = binding.get_serviceAttributeDetail(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public DispositionReport delete_serviceAttribute(Delete_serviceAttribute
            body) throws DispositionReport {
        DispositionReport value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();

            Get_authToken get_authtoken = new Get_authToken();
            get_authtoken.setUserID("uddi_user");
            get_authtoken.setCred("changeIt");

            AuthToken token = null;
            try {
                token = binding.get_authToken(get_authtoken);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
            }
            AuthInfo authinfo = token.getAuthInfo();
            //String publisher_id = authinfo.getPublisherID();
            //String publisher_cred = authinfo.getValue();
            //System.out.println("publisher_id = " + publisher_id + " publisher_cred = " + publisher_cred);

            body.setAuthInfo(authinfo);

            try {
                value = binding.delete_serviceAttribute(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public BusinessDetail save_business(Save_business body) throws
            DispositionReport {
        BusinessDetail value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();

            Get_authToken get_authtoken = new Get_authToken();
            get_authtoken.setUserID("uddi_user");
            get_authtoken.setCred("changeIt");

            AuthToken token = null;
            try {
                token = binding.get_authToken(get_authtoken);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
            }
            AuthInfo authinfo = token.getAuthInfo();
            //String publisher_id = authinfo.getPublisherID();
            //String publisher_cred = authinfo.getValue();
            //System.out.println("publisher_id = " + publisher_id + " publisher_cred = " + publisher_cred);

            body.setAuthInfo(authinfo);

            try {
                value = binding.save_business(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public BusinessList find_business(Find_business body) throws
            DispositionReport {
        BusinessList value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();
            //DispositionReport fault = null;
            try {
                value = binding.find_business(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public DispositionReport delete_business(Delete_business body) throws
            DispositionReport {
        DispositionReport value = null;
        if (body != null) {
            UDDI_ExtendedSoapBindingStub binding = null;
            binding = getbinding();

            Get_authToken get_authtoken = new Get_authToken();
            get_authtoken.setUserID("uddi_user");
            get_authtoken.setCred("changeIt");

            AuthToken token = null;
            try {
                token = binding.get_authToken(get_authtoken);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
            }
            AuthInfo authinfo = token.getAuthInfo();
            //String publisher_id = authinfo.getPublisherID();
            //String publisher_cred = authinfo.getValue();
            //System.out.println("publisher_id = " + publisher_id + " publisher_cred = " + publisher_cred);

            body.setAuthInfo(authinfo);

            //DispositionReport fault = null;
            try {
                value = binding.delete_business(body);
            } catch (DispositionReport e1) {
                throw new junit.framework.AssertionFailedError(
                        "DispositionReport Exception caught: " + e1);
            } catch (Exception e) {
                e.printStackTrace();
                //fault = new DispositionReport();
            }
        }
        // TBD - validate results
        return value;
    }

    /**
     *
     */
    public PublisherDetail get_publisherDetail(Get_publisherDetail body) throws
            DispositionReport {
        ////////////////////////////////////////////////////////////////////////
        PublisherDetail axis_publisherDetail = null;
        if (body != null) {
            String[] publisherIDArray = body.getPublisherID();
            if (publisherIDArray != null) {
                cgl.fthpis.datatype.request.AuthInfo
                        juddi_authinfo = new cgl.fthpis.datatype.request.
                                         AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());

                log.info("value = " + info.getValue());
                log.info("publisherID = " + info.getPublisherID());
                //////////////////////////////////////////////////////////////////////////
                cgl.fthpis.datatype.response.PublisherDetail publisher_detail = null;
                Vector publishervector = null;
                axis_publisherDetail = new PublisherDetail();
                // Context[] axis_context_array = contextbag.getContext();
                try {
                    publishervector = uddi_wscontext_helper.
                                      constructFTHPIS_PublisherVector(
                                              publisherIDArray);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
                //////////////////////////////////////////////////////////////////////////
                try {
                    publisher_detail = fthpis_engine.getPublisherDetail(
                            juddi_authinfo, publishervector);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    log.info(ex.getMessage());
                }
                //////////////////////////////////////////////////////////////////////////
                PublisherEntity[] publisher_entity_arr = null;
                try {
                    if (publisher_detail != null) {
                        Vector pubVector = publisher_detail.getPublisherVector();
                        if (pubVector != null && pubVector.size() != 0) {
                            publisher_entity_arr = new PublisherEntity[
                                    pubVector.size()];
                            int pub_count = 0;
                            if (pubVector != null && pubVector.size() != 0) {
                                for (Iterator iter = pubVector.iterator();
                                        iter.hasNext(); ) {
                                    cgl.fthpis.datatype.publisher.Publisher
                                            pub = (cgl.fthpis.datatype.
                                            publisher.Publisher) iter.next();

                                    PublisherEntity entity = new
                                            PublisherEntity();
                                    entity.setPublisherID(pub.getPublisherID());

                                    publisher_entity_arr[pub_count] = entity;
                                    pub_count++;
                                }
                            }
                        }
                        axis_publisherDetail.setPublisherEntity(
                                publisher_entity_arr);
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return axis_publisherDetail;
    }

    /**
     *
     */
    public PublisherDetail save_publisher(Save_publisher body) throws
            DispositionReport {
        ////////////////////////////////////////////////////////////////////////
        //log.info("save_publisher I");
        PublisherDetail axis_publisherDetail = null;
        if (body != null) {
            PublisherEntity[] publisherEntityArr = body.getPublisherEntity();
            if (publisherEntityArr != null) {
                cgl.fthpis.datatype.request.AuthInfo juddi_authinfo =
                        new cgl.fthpis.datatype.request.AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());

                log.info("value = " + info.getValue());
                log.info("publisherID = " + info.getPublisherID());
                //////////////////////////////////////////////////////////////////////////
                cgl.fthpis.datatype.response.PublisherDetail publisher_detail = null;
                Vector publishervector = null;
                //log.info("save_publisher II");
                axis_publisherDetail = new PublisherDetail();
                // Context[] axis_context_array = contextbag.getContext();
                publishervector = uddi_wscontext_helper.
                                  constructFTHPIS_PublisherVector(
                                          publisherEntityArr);
                //log.info("save_publisher III " + " publishervector = " +
                //         publishervector);

                //////////////////////////////////////////////////////////////////////////
                //log.info("save_publisher IV");
                try {
                    publisher_detail = fthpis_engine.savePublisher(
                            juddi_authinfo, publishervector);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    log.info(ex.getMessage());
                }
                //log.info("save_publisher V");
                //////////////////////////////////////////////////////////////////////////
                PublisherEntity[] publisher_entity_arr = null;
                try {
                    if (publisher_detail != null) {
                        Vector pubVector = publisher_detail.getPublisherVector();
                        if (pubVector != null && pubVector.size() != 0) {
                            publisher_entity_arr = new PublisherEntity[
                                    pubVector.size()];
                            //log.info("save_publisher VI");
                            int pub_count = 0;
                            if (pubVector != null && pubVector.size() != 0) {
                                for (Iterator iter = pubVector.iterator();
                                        iter.hasNext(); ) {
                                    //log.info("save_publisher VII");
                                    cgl.fthpis.datatype.publisher.Publisher
                                            pub = (cgl.fthpis.datatype.
                                            publisher.Publisher) iter.next();

                                    PublisherEntity entity = new
                                            PublisherEntity();
                                    entity.setPublisherID(pub.getPublisherID());

                                    publisher_entity_arr[pub_count] = entity;
                                    pub_count++;
                                }
                            }
                        }
                        //log.info("save_publisher IX");
                        axis_publisherDetail.setPublisherEntity(
                                publisher_entity_arr);
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return axis_publisherDetail;
    }

    /**
     *
     */
    public PublisherList find_publisher(Find_publisher body) throws
            DispositionReport {

        cgl.fthpis.datatype.response.PublisherList publisherList = null;

        PublisherList axis_publisherList = null;

        if (body != null) {
            publisherList = new cgl.fthpis.datatype.response.PublisherList();
            axis_publisherList = new PublisherList();
            Name[] name_array = body.getName();
            String publisher_name = null;
            if (name_array != null) {
                cgl.fthpis.datatype.request.AuthInfo
                        juddi_authinfo = new cgl.fthpis.datatype.request.
                                         AuthInfo();
                cgl.axis.services.uddi.uddi_schema.AuthInfo info = body.
                        getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());

                log.info("value = " + info.getValue());
                log.info("publisherID = " + info.getPublisherID());

                FindQualifiers axis_findqualifiers = body.getFindQualifiers();

                String[] findqualifier_array = axis_findqualifiers.
                                               getFindQualifier();

                int max_rows = body.getMaxRows();

                Vector namesVector = null;
                org.apache.juddi.datatype.request.FindQualifiers
                        juddi_findQualifiers = null;

                try {
                    namesVector = new Vector();
                    for (int i = 0; i < name_array.length; i++) {
                        Name name = name_array[i];
                        namesVector.add(new org.apache.juddi.datatype.Name(name.
                                getValue().toString()));
                        publisher_name = name.getValue().toString();
                    }

                    juddi_findQualifiers = new org.apache.juddi.datatype.
                                           request.
                                           FindQualifiers();
                    Vector findQualifierVector = new Vector();
                    int size = findqualifier_array.length;
                    for (int i = 0; i < size; i++) {
                        String fieldname = findqualifier_array[i];
                        org.apache.juddi.datatype.request.FindQualifier
                                juddi_findQualifier
                                = new org.apache.juddi.datatype.request.
                                  FindQualifier(
                                          fieldname);
                        findQualifierVector.add(juddi_findQualifier);
                    }
                    juddi_findQualifiers.setFindQualifierVector(
                            findQualifierVector);
                } catch (Exception ex) {
                    ex.printStackTrace();
                }

                //log.info("debug point II");

                try {
                    publisherList = fthpis_engine.findPublisher(juddi_authinfo,
                            publisher_name,
                            juddi_findQualifiers,
                            max_rows);
                    fthpis_engine.dispose();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }

                //log.info("debug point III");

                try {
                    PublisherInfos axis_publisher_infos = new PublisherInfos();
                    PublisherInfo[] publisher_info_array = null;
                    if (publisherList != null) {

                        if (publisherList.getPublisherInfos() != null) {
                            Vector publisherInfoVector =
                                    publisherList.getPublisherInfos().
                                    getPublisherInfoVector();
                            if (publisherInfoVector != null) {
                                int publisher_size = publisherInfoVector.size();
                                publisher_info_array = new PublisherInfo[
                                        publisher_size];
                                int publisher_count = 0;
                                //log.info("debug point IV");
                                for (Iterator iter = publisherInfoVector.
                                        iterator(); iter.hasNext(); ) {

                                    cgl.fthpis.datatype.response.PublisherInfo
                                            juddi_publisherInfo = (cgl.fthpis.
                                            datatype.response.PublisherInfo)
                                            iter.next();

                                    PublisherInfo axis_publisher_info = new
                                            PublisherInfo();

                                    String publisherID = juddi_publisherInfo.
                                            getPublisherID();
                                    axis_publisher_info.setPublisherID(
                                            publisherID);
                                    publisher_info_array[publisher_count] =
                                            axis_publisher_info;
                                    publisher_count++;
                                }
                                //log.info("debug point V");
                                axis_publisher_infos.setPublisherInfo(
                                        publisher_info_array);
                                axis_publisherList.setPublisherInfos(
                                        axis_publisher_infos);
                            }
                        }
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
        return axis_publisherList;
    }

    /**
     *
     */
    public DispositionReport delete_publisher(Delete_publisher body) throws
            DispositionReport {
        DispositionReport fault = null;
        org.apache.juddi.datatype.response.DispositionReport dr = null;
        if (body != null) {
            String[] publisher_ID = body.getPublisherID();
            if (publisher_ID != null && publisher_ID.length != 0) {
                cgl.fthpis.datatype.request.AuthInfo
                        juddi_authinfo = new cgl.fthpis.datatype.request.
                                         AuthInfo();
                AuthInfo info = body.getAuthInfo();
                juddi_authinfo.setValue(info.getValue());
                juddi_authinfo.setPublisherID(info.getPublisherID());

                Vector publisherIDVector =
                        uddi_wscontext_helper.constructFTHPIS_PublisherVector(
                                body.getPublisherID());
                fault = new DispositionReport();
                try {
                    ////////////////////////////////////////////////////////////////
                    dr = fthpis_engine.deletePublisher(juddi_authinfo,
                            publisherIDVector);
                    fthpis_engine.dispose();
                    ////////////////////////////////////////////////////////////////
                    Vector resultvector = dr.getResultVector();
                    if (resultvector != null) {
                        Result[] axis_result_array = new Result[resultvector.
                                size()];
                        int i = 0;
                        for (Iterator iter = resultvector.iterator();
                                             iter.hasNext(); ) {
                            org.apache.juddi.datatype.response.Result
                                    result = (org.apache.juddi.datatype.
                                              response.Result) iter.next();
                            int errno = result.getErrno();
                            log.info("error no = " + errno);
                            log.info("error message = " + result.getErrInfo());
                            Result axis_result = new Result();
                            result.setErrno(errno);
                            axis_result_array[i] = axis_result;
                        }
                        fault.setResult(axis_result_array);
                    }
                } catch (Exception e) {
                    try {
                        log.warn("UDDIException faultCode: " + e);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        fault = new
                                DispositionReport();
                    }
                }
            }
        }
        return fault;
    }
}
