/*
 * Indiana University Community Grid Computing Lab Software License,Version 1.1
 *
 * Copyright (c) 2002 Community Grid Computing Lab, Indiana University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes software developed by the Indiana University
 *       Community Grid Computing Lab (http://www.communitygrids.iu.edu/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Indiana Univeristy","Indiana Univeristy Pervasive Techonology
 *    Labs" and  "Indiana Univeristy Community Grid Computing Lab" must not be
 *    used to endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    http://www.communitygrids.iu.edu/.
 *
 * 5. Products derived from this software may not use "Indiana
 *    University" name nor may "Indiana University" appear in their name,
 *    without prior written permission of the Indiana University.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * INDIANA UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package cgl.fthpis.datatype;

import org.apache.juddi.datatype.RegistryObject;
import java.sql.Timestamp;

/**
 * @author Mehmet S. Aktas (maktas@indiana.edu)
 */
public class AutharizationToken implements RegistryObject {
    private String auth_token;
    private String publisher_id;
    private String publisher_name;
    private Timestamp created;
    private Timestamp last_used;
    private int num_of_uses;
    private int token_state;

    /**
     *
     */
    public AutharizationToken() {
    }

    /**
     *
     */
    public String getAuthtoken() {
        return this.auth_token;
    }

    /**
     *
     */
    public void setAuthtoken(String token) {
        this.auth_token = token;
    }

    /**
     *
     */
    public String getPublisher_ID() {
        return this.publisher_id;
    }

    /**
     *
     */
    public void setPublisher_ID(String id) {
        this.publisher_id = id;
    }

    /**
     *
     */
    public String getPublisher_Name() {
        return this.publisher_name;
    }

    /**
     *
     */
    public void setPublisher_Name(String name) {
        this.publisher_name = name;
    }

    /**
     *
     */
    public Timestamp get_created() {
        return this.created;
    }

    /**
     *
     */
    public void set_created(Timestamp c) {
        this.created = c;
    }

    /**
     *
     */
    public Timestamp get_lastUsed() {
        return this.last_used;
    }

    /**
     *
     */
    public void set_lastUsed(Timestamp c) {
        this.last_used = c;
    }

    /**
     *
     */
    public int get_numOfUses() {
        return this.num_of_uses;
    }

    /**
     *
     */
    public void set_numOfUses(int i) {
        this.num_of_uses = i;
    }

    /**
     *
     */
    public int get_token_state() {
        return this.token_state;
    }

    /**
     *
     */
    public void set_token_state(int i) {
        this.token_state = i;
    }

   /***************************************************************************/
   /***************************************************************************/


    public static void main(String[] args) {
    }
}
