/*
 * Indiana University Community Grid Computing Lab Software License,Version 1.1
 *
 * Copyright (c) 2002 Community Grid Computing Lab, Indiana University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *      "This product includes software developed by the Indiana University
 *       Community Grid Computing Lab (http://www.communitygrids.iu.edu/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Indiana Univeristy","Indiana Univeristy Pervasive Techonology
 *    Labs" and  "Indiana Univeristy Community Grid Computing Lab" must not be
 *    used to endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    http://www.communitygrids.iu.edu/.
 *
 * 5. Products derived from this software may not use "Indiana
 *    University" name nor may "Indiana University" appear in their name,
 *    without prior written permission of the Indiana University.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * INDIANA UNIVERSITY OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
 * OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


package cgl.fthpis.datatype.response;

import java.util.Vector;

import org.apache.juddi.datatype.Name;
import org.apache.juddi.datatype.RegistryObject;
import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;

import cgl.fthpis.datatype.attribute.AttributeBag;
import cgl.fthpis.datatype.attribute.Attribute;
import cgl.fthpis.datatype.lease.Lease;
import cgl.fthpis.datatype.SessionKey;

/**
 * @author Mehmet S. Aktas (maktas@indiana.edu)
 */
public class ServiceInfo
{
  // private reference to the FTHPIS logger
  private static Log log = LogFactory.getLog(ServiceInfo.class);

  //bare minimum information
  String serviceKey;

//  Vector nameVector;
//  String businessKey;
//  Vector sessionKeyVector;
//  AttributeBag contextBag;
//  AttributeBag attributeBag;
//  Lease lease;

  /**
   * default constructor
   */
  public ServiceInfo()
  {
      log.info("cgl.fthpis.datatype.response.ServiceInfo() constructor called.");
  }

  /**
   *
   */
  public void setServiceKey(String key)
  {
    this.serviceKey = key;
  }

  /**
   *
   */
  public String getServiceKey()
  {
    return this.serviceKey;
  }

//  /**
//   *
//   */
//  public void setBusinessKey(String key)
//  {
//    this.businessKey = key;
//  }
//
//  /**
//   *
//   */
//  public String getBusinessKey()
//  {
//    return businessKey;
//  }
//
//  /**
//   *
//   */
//  public void addName(Name name)
//  {
//    if (this.nameVector == null)
//      this.nameVector = new Vector();
//    this.nameVector.add(name);
//  }

//  /**
//   *
//   */
//  public void setNameVector(Vector names)
//  {
//    this.nameVector = names;
//  }
//
//  /**
//   *
//   */
//  public Vector getNameVector()
//  {
//    return this.nameVector;
//  }

//  public void addContextBag(Attribute context) {
//    if (this.contextBag == null)
//      this.contextBag = new AttributeBag();
//    //log.info("ServiceInfo.addContextBag() context = " + context.getName());
//    this.contextBag.addAttribute(context);
//  }
//
//  public void setContextBag(AttributeBag contextBag) {
//    this.contextBag = contextBag;
//  }
//
//  public AttributeBag getContextBag() {
//    return this.contextBag;
//  }
//
//  public void addAttributeBag(Attribute attribute) {
//    if (this.attributeBag == null)
//      this.attributeBag = new AttributeBag();
//    //log.info("ServiceInfo.addAttributeBag() attribute = " + attribute.getName());
//    this.attributeBag.addAttribute(attribute);
//  }
//
//  public void setAttributeBag(AttributeBag attributeBag) {
//    this.attributeBag = attributeBag;
//  }
//
//  public AttributeBag getAttributeBag() {
//    return this.attributeBag;
//  }
//
//  public void setLease(Lease lease) {
//    this.lease = lease;
//  }
//
//  public Lease getLease() {
//    return this.lease;
//  }

//  /**
//   * Sets the name argument of the search to the given name. This value is a partial
//   * name. The serviceList return contains ServiceInfo objects for services whose
//   * name matches the value passed (leftmost match).
//   *
//   * @param nameValue The name argument of the search.
//   */
//  public void addSessionKey(SessionKey sessionKey)
//  {
//    if (this.sessionKeyVector == null)
//      this.sessionKeyVector = new Vector();
//    this.sessionKeyVector.add(sessionKey);
//  }
//
//  /**
//   * Returns the name argument of the search. Null is returned if the name
//   * argument for this search has not been specified.
//   *
//   * @return The name argument of the search, or null if the argument has not been specified.
//   */
//  public Vector getSessionKeyVector()
//  {
//    return this.sessionKeyVector;
//  }

//  /**
//   * Sets the name argument of the search to the given name. This value is a partial
//   * name. The serviceList return contains ServiceInfo objects for services whose
//   * name matches the value passed (leftmost match).
//   *
//   * @param names The name argument of the search.
//   */
//  public void setSessionKeyVector(Vector vec)
//  {
//    this.sessionKeyVector = vec;
//  }

}
